'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Dropdown = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DomHandler = require('../utils/DomHandler');

var _DomHandler2 = _interopRequireDefault(_DomHandler);

var _ObjectUtils = require('../utils/ObjectUtils');

var _ObjectUtils2 = _interopRequireDefault(_ObjectUtils);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = exports.Dropdown = function (_Component) {
    _inherits(Dropdown, _Component);

    function Dropdown(props) {
        _classCallCheck(this, Dropdown);

        var _this = _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

        _this.state = { panelVisible: false, focus: false, optionsToDisplay: _this.props.options };
        _this.onMouseclick = _this.onMouseclick.bind(_this);
        _this.onInputFocus = _this.onInputFocus.bind(_this);
        _this.onInputBlur = _this.onInputBlur.bind(_this);
        _this.onKeydown = _this.onKeydown.bind(_this);
        _this.onEditableInputClick = _this.onEditableInputClick.bind(_this);
        _this.onEditableInputChange = _this.onEditableInputChange.bind(_this);
        _this.onEditableInputFocus = _this.onEditableInputFocus.bind(_this);
        _this.onInputBlur = _this.onInputBlur.bind(_this);
        _this.onFilter = _this.onFilter.bind(_this);

        _this.value = _this.props.value;
        _this.optionsToDisplay = _this.props.options;
        if (_this.value) {
            _this.updateSelectedOption(_this.value);
        }

        if (_this.filterValue && _this.filterValue.length) {
            _this.activateFilter();
        }
        return _this;
    }

    _createClass(Dropdown, [{
        key: 'getLabel',
        value: function getLabel() {
            return this.selectedOption ? this.selectedOption.label : this.props.placeholder;
        }
    }, {
        key: 'updateEditableLabel',
        value: function updateEditableLabel() {
            if (this.editableInput) {
                this.editableInput.value = this.selectedOption ? this.selectedOption.label : this.value || '';
            }
        }
    }, {
        key: 'updateOptions',
        value: function updateOptions() {
            var _this2 = this;

            if (this.optionsChanged && this.panelVisible) {
                this.optionsChanged = false;

                setTimeout(function () {
                    _this2.updateDimensions();
                    _this2.alignPanel();
                }, 1);
            }
        }
    }, {
        key: 'onItemClick',
        value: function onItemClick(event, option) {
            this.itemClick = true;
            this.selectItem(event, option);
            this.hiddenInput.focus();

            this.hide();
        }
    }, {
        key: 'selectItem',
        value: function selectItem(event, option) {
            if (this.selectedOption !== option) {
                this.selectedOption = option;
                this.value = option.value;

                this.updateEditableLabel();
                this.props.onChange({
                    originalEvent: event,
                    value: this.value
                });
            }
        }
    }, {
        key: 'resetFilter',
        value: function resetFilter() {
            if (this.filterInput) {
                this.filterInput.value = '';
            }

            this.optionsToDisplay = this.props.options;
            this.setState({ optionsToDisplay: this.optionsToDisplay });
        }
    }, {
        key: 'updateSelectedOption',
        value: function updateSelectedOption(val) {
            this.selectedOption = this.findOption(val, this.optionsToDisplay);
            if (!this.props.placeholder && !this.selectedOption && this.optionsToDisplay && this.optionsToDisplay.length && !this.props.editable) {
                this.selectedOption = this.optionsToDisplay[0];
            }
            this.selectedOptionUpdated = true;
        }
    }, {
        key: 'updateDimensions',
        value: function updateDimensions() {
            if (this.props.autoWidth) {
                var select = _DomHandler2.default.findSingle(this.container, 'select');
                if (!this.props.style || !this.props.style['width'] && !this.props.style['min-width']) {
                    this.container.children[0].style.width = select.offsetWidth + 30 + 'px';
                }
            }
        }
    }, {
        key: 'onMouseclick',
        value: function onMouseclick(event) {
            var _this3 = this;

            if (this.props.disabled || this.props.readonly) {
                return;
            }

            this.selfClick = true;

            if (!this.itemClick) {
                this.hiddenInput.focus();

                if (this.state.panelVisible) this.hide();else {
                    this.show();

                    if (this.filterInput !== undefined) {
                        setTimeout(function () {
                            _this3.filterInput.focus();
                        }, 200);
                    }
                }
            }
        }
    }, {
        key: 'onEditableInputClick',
        value: function onEditableInputClick(event) {
            this.itemClick = true;
            this.bindDocumentClickListener();
        }
    }, {
        key: 'onEditableInputFocus',
        value: function onEditableInputFocus(event) {
            this.setState({ focus: true });
            this.hide();
        }
    }, {
        key: 'onEditableInputChange',
        value: function onEditableInputChange(event) {
            this.value = event.target.value;
            this.updateSelectedOption(this.value);

            this.props.onChange({
                originalEvent: event,
                value: this.value
            });
        }
    }, {
        key: 'onShow',
        value: function onShow() {
            if (this.props.options && this.props.options.length) {
                this.alignPanel();
                this.bindDocumentClickListener();

                var selectedListItem = _DomHandler2.default.findSingle(this.itemsWrapper, '.ui-dropdown-item.ui-state-highlight');
                if (selectedListItem) {
                    _DomHandler2.default.scrollInView(this.itemsWrapper, selectedListItem);
                }
            }
        }
    }, {
        key: 'show',
        value: function show() {
            if (this.props.appendTo) {
                this.panel.style.minWidth = _DomHandler2.default.getWidth(this.container) + 'px';
            }

            var zIndex = _DomHandler2.default.getZindex() + 1;
            this.panel.style.zIndex = String(zIndex);
            this.panelVisible = true;
            this.onShow();

            this.setState({ panelVisible: this.panelVisible });
        }
    }, {
        key: 'hide',
        value: function hide() {
            this.panelVisible = false;
            this.setState({ panelVisible: this.panelVisible });
        }
    }, {
        key: 'alignPanel',
        value: function alignPanel() {
            if (this.props.appendTo) _DomHandler2.default.absolutePosition(this.panel, this.container);else _DomHandler2.default.relativePosition(this.panel, this.container);
        }
    }, {
        key: 'onInputFocus',
        value: function onInputFocus(event) {
            this.focus = true;
            this.setState({ focus: this.focus });

            if (this.props.onFocus) {
                this.props.onFocus({
                    originalEvent: event
                });
            }
        }
    }, {
        key: 'onInputBlur',
        value: function onInputBlur(event) {
            this.focus = false;
            this.setState({ focus: this.focus });
            this.selfClick = false;

            if (this.props.onBlur) {
                this.props.onBlur({
                    originalEvent: event
                });
            }
        }
    }, {
        key: 'onKeydown',
        value: function onKeydown(event) {
            if (this.props.readonly) {
                return;
            }

            var selectedItemIndex = this.selectedOption ? this.findOptionIndex(this.selectedOption.value, this.optionsToDisplay) : -1;

            switch (event.which) {
                //down
                case 40:
                    if (!this.panelVisible && event.altKey) {
                        this.show();
                    } else {
                        if (selectedItemIndex !== -1) {
                            var nextItemIndex = selectedItemIndex + 1;
                            if (nextItemIndex !== this.optionsToDisplay.length) {
                                this.selectItem(event, this.optionsToDisplay[nextItemIndex]);
                                this.selectedOptionUpdated = true;
                            }
                        } else if (this.optionsToDisplay) {
                            this.selectItem(event, this.optionsToDisplay[0]);
                        }
                    }

                    event.preventDefault();

                    break;

                //up
                case 38:
                    if (selectedItemIndex > 0) {
                        var prevItemIndex = selectedItemIndex - 1;
                        this.selectItem(event, this.optionsToDisplay[prevItemIndex]);
                        this.selectedOptionUpdated = true;
                    }

                    event.preventDefault();
                    break;

                //space
                case 32:
                    if (!this.panelVisible) {
                        this.show();
                        event.preventDefault();
                    }
                    break;

                //enter
                case 13:
                    this.hide();

                    event.preventDefault();
                    break;

                //escape and tab
                case 27:
                case 9:
                    this.hide();
                    break;

                default:
                    break;
            }
        }
    }, {
        key: 'findOptionIndex',
        value: function findOptionIndex(val, opts) {
            var index = -1;
            if (opts) {
                for (var i = 0; i < opts.length; i++) {
                    if (val == null && opts[i].value == null || _ObjectUtils2.default.equals(val, opts[i].value, this.props.dataKey)) {
                        index = i;
                        break;
                    }
                }
            }

            return index;
        }
    }, {
        key: 'findOption',
        value: function findOption(val, opts) {
            var index = this.findOptionIndex(val, opts);
            return index !== -1 ? opts[index] : null;
        }
    }, {
        key: 'onFilter',
        value: function onFilter(event) {
            var inputValue = event.target.value.toLowerCase();
            if (inputValue && inputValue.length) {
                this.filterValue = inputValue;
                this.activateFilter();
            } else {
                this.filterValue = null;
                this.optionsToDisplay = this.props.options;
                this.setState({ optionsToDisplay: this.optionsToDisplay });
            }

            this.optionsChanged = true;
            this.updateOptions();
        }
    }, {
        key: 'activateFilter',
        value: function activateFilter() {
            var searchFields = this.props.filterBy.split(',');
            if (this.props.options && this.props.options.length) {
                this.optionsToDisplay = _ObjectUtils2.default.filter(this.props.options, searchFields, this.filterValue);
                this.setState({ optionsToDisplay: this.optionsToDisplay });
                this.optionsChanged = true;
                this.updateOptions();
            }
        }
    }, {
        key: 'applyFocus',
        value: function applyFocus() {
            if (this.props.editable) _DomHandler2.default.findSingle(this.container, '.ui-dropdown-label.ui-inputtext').focus();else _DomHandler2.default.findSingle(this.container, 'input[readonly]').focus();
        }
    }, {
        key: 'bindDocumentClickListener',
        value: function bindDocumentClickListener() {
            var _this4 = this;

            if (!this.documentClickListener) {
                this.documentClickListener = function () {
                    if (!_this4.selfClick && !_this4.itemClick) {
                        _this4.panelVisible = false;
                        _this4.unbindDocumentClickListener();
                        _this4.setState({ panelVisible: _this4.panelVisible });
                    }

                    _this4.selfClick = false;
                    _this4.itemClick = false;
                };

                document.addEventListener('click', this.documentClickListener);
            }
        }
    }, {
        key: 'unbindDocumentClickListener',
        value: function unbindDocumentClickListener() {
            if (this.documentClickListener) {
                document.removeEventListener('click', this.documentClickListener);
                this.documentClickListener = null;
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (this.props.editable) {
                this.updateEditableLabel();
            }

            this.updateDimensions();
            this.initialized = true;

            if (this.props.appendTo) {
                if (this.props.appendTo === 'body') document.body.appendChild(this.panel);else _DomHandler2.default.appendChild(this.panel, this.props.appendTo);
            }

            if (this.filterContainer && !this.onFilterClick) {
                this.onFilterClick = this.filterContainer.addEventListener("click", function (event) {
                    event.stopPropagation();
                });
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (!_ObjectUtils2.default.equals(nextProps.options, this.props.options)) {
                this.optionsToDisplay = nextProps.options;
                this.optionsChanged = true;

                this.updateSelectedOption(this.value);
                if (this.filterValue && this.filterValue.length) {
                    this.activateFilter();
                }
            }
        }
    }, {
        key: 'componentDidUpdate',
        value: function componentDidUpdate(prevProps, prevState) {
            if (this.selectedOptionUpdated && this.itemsWrapper) {
                var selectedItem = _DomHandler2.default.findSingle(this.panel, 'li.ui-state-highlight');
                if (selectedItem) {
                    _DomHandler2.default.scrollInView(this.itemsWrapper, selectedItem);
                }
                this.selectedOptionUpdated = false;
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            this.initialized = false;

            this.unbindDocumentClickListener();

            if (this.props.appendTo) {
                this.container.appendChild(this.panel);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _this5 = this;

            var styleClass = (0, _classnames2.default)('ui-dropdown ui-widget ui-state-default ui-corner-all ui-helper-clearfix', this.props.className, {
                'ui-state-disabled': this.props.disabled,
                'ui-dropdown-open': this.state.panelVisible,
                'ui-state-focus': this.state.focus
            });

            var hiddenSelectElement = void 0;
            if (this.props.autoWidth) {
                hiddenSelectElement = _react2.default.createElement(
                    'div',
                    { className: 'ui-helper-hidden-accessible' },
                    _react2.default.createElement(
                        'select',
                        { required: this.props.required, name: 'options', tabIndex: '-1' },
                        this.props.options && this.props.options.map(function (option, index) {
                            return _react2.default.createElement(
                                'option',
                                { value: option.value, key: "option_" + option.label },
                                option.label
                            );
                        })
                    )
                );
            }

            var hiddenInputElement = _react2.default.createElement(
                'div',
                { className: 'ui-helper-hidden-accessible' },
                _react2.default.createElement('input', { ref: function ref(el) {
                        return _this5.hiddenInput = el;
                    }, type: 'text', readOnly: true, onFocus: this.onInputFocus, role: 'listbox',
                    onBlur: this.onInputBlur, onKeyDown: this.onKeydown, disabled: this.props.disabled, tabIndex: this.props.tabindex, autoFocus: this.props.autofocus })
            );

            var labelElement = void 0;
            if (!this.props.editable) {
                var label = this.getLabel(),
                    labelElementClass = (0, _classnames2.default)('ui-dropdown-label ui-inputtext ui-corner-all', {
                    'ui-dropdown-label-empty': !label
                });

                labelElement = _react2.default.createElement(
                    'label',
                    { className: labelElementClass },
                    label || 'empty'
                );
            } else {
                labelElement = _react2.default.createElement('input', { ref: function ref(el) {
                        return _this5.editableInput = el;
                    }, type: 'text', className: 'ui-dropdown-label ui-inputtext ui-corner-all', disabled: this.props.disabled,
                    placeholder: this.props.placeholder, onClick: this.onEditableInputClick, onInput: this.onEditableInputChange,
                    onFocus: this.onEditableInputFocus, onBlur: this.onInputBlur });
            }

            var trigger = _react2.default.createElement(
                'div',
                { className: 'ui-dropdown-trigger ui-state-default ui-corner-right' },
                _react2.default.createElement('span', { className: 'fa fa-fw fa-caret-down ui-clickable' })
            );

            var filterContainer = void 0;
            if (this.props.filter) {
                filterContainer = _react2.default.createElement(
                    'div',
                    { ref: function ref(el) {
                            return _this5.filterContainer = el;
                        }, className: 'ui-dropdown-filter-container', onInput: this.onFilter },
                    _react2.default.createElement('input', { ref: function ref(el) {
                            return _this5.filterInput = el;
                        }, type: 'text', autoComplete: 'off', className: 'ui-dropdown-filter ui-inputtext ui-widget ui-state-default ui-corner-all',
                        placeholder: this.props.filterPlaceholder, onKeyDown: this.onKeydown }),
                    _react2.default.createElement('span', { className: 'fa fa-search' })
                );
            }

            var listItems = void 0,
                isRendered = this.props.lazy ? this.state.panelVisible : true;
            if (isRendered) {
                listItems = _react2.default.createElement(
                    'ul',
                    { className: 'ui-dropdown-items ui-dropdown-list ui-widget-content ui-widget ui-corner-all ui-helper-reset' },
                    this.state.optionsToDisplay && this.state.optionsToDisplay.map(function (option, index) {
                        var listItemContent = _this5.props.itemTemplate ? _this5.props.itemTemplate(option) : _react2.default.createElement(
                            'span',
                            null,
                            option.label || 'empty'
                        ),
                            itemClass = (0, _classnames2.default)('ui-dropdown-item ui-corner-all', {
                            'ui-state-highlight': _this5.selectedOption && _this5.selectedOption.label === option.label,
                            'ui-dropdown-item-empty': !option.label || option.label.length === 0
                        });

                        return _react2.default.createElement(
                            'li',
                            { className: itemClass, onClick: function onClick(e) {
                                    return _this5.onItemClick(e, option);
                                }, key: 'dd_item_' + option.label },
                            listItemContent
                        );
                    })
                );
            }

            var panelStyle = Object.assign({ 'display': this.state.panelVisible ? 'block' : 'none' }, this.props.panelStyle),
                panelStyleClass = (0, _classnames2.default)('ui-dropdown-panel ui-widget-content ui-corner-all ui-helper-hidden ui-shadow', this.props.panelStyleClass),
                panel = _react2.default.createElement(
                'div',
                { ref: function ref(el) {
                        return _this5.panel = el;
                    }, className: panelStyleClass, style: panelStyle },
                filterContainer,
                _react2.default.createElement(
                    'div',
                    { ref: function ref(el) {
                            return _this5.itemsWrapper = el;
                        }, className: 'ui-dropdown-items-wrapper', style: { 'maxHeight': this.props.scrollHeight || 'auto' } },
                    listItems
                )
            );

            return _react2.default.createElement(
                'div',
                { id: this.props.id, ref: function ref(el) {
                        return _this5.container = el;
                    }, className: styleClass, style: this.props.style, onClick: this.onMouseclick },
                hiddenSelectElement,
                hiddenInputElement,
                labelElement,
                trigger,
                panel
            );
        }
    }]);

    return Dropdown;
}(_react.Component);

Dropdown.defaultProps = {
    id: null,
    value: null,
    options: null,
    onChange: null,
    itemTemplate: null,
    style: null,
    className: null,
    autoWidth: true,
    scrollHeight: '200px',
    filter: false,
    filterBy: null,
    filterPlaceholder: null,
    editable: false,
    placeholder: null,
    required: false,
    disabled: false,
    appendTo: null,
    tabindex: null,
    autofocus: false,
    lazy: true,
    panelStyleClass: null,
    panelStyle: null,
    dataKey: null
};
Dropdown.propTypes = {
    id: _propTypes2.default.string,
    value: _propTypes2.default.any,
    options: _propTypes2.default.array,
    onChange: _propTypes2.default.func,
    itemTemplate: _propTypes2.default.func,
    style: _propTypes2.default.object,
    className: _propTypes2.default.string,
    autoWidth: _propTypes2.default.bool,
    scrollHeight: _propTypes2.default.string,
    filter: _propTypes2.default.bool,
    filterBy: _propTypes2.default.string,
    filterPlaceholder: _propTypes2.default.string,
    editable: _propTypes2.default.bool,
    placeholder: _propTypes2.default.string,
    required: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    appendTo: _propTypes2.default.any,
    tabindex: _propTypes2.default.number,
    autofocus: _propTypes2.default.bool,
    lazy: _propTypes2.default.bool,
    panelStyleClass: _propTypes2.default.string,
    panelStyle: _propTypes2.default.string,
    dataKey: _propTypes2.default.string
};