'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Paginator = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Paginator = exports.Paginator = function (_Component) {
    _inherits(Paginator, _Component);

    function Paginator(props) {
        _classCallCheck(this, Paginator);

        var _this = _possibleConstructorReturn(this, (Paginator.__proto__ || Object.getPrototypeOf(Paginator)).call(this, props));

        _this.changePageToFirst = _this.changePageToFirst.bind(_this);
        _this.changePageToPrev = _this.changePageToPrev.bind(_this);
        _this.changePageToNext = _this.changePageToNext.bind(_this);
        _this.changePageToLast = _this.changePageToLast.bind(_this);
        _this.onRowsChange = _this.onRowsChange.bind(_this);
        return _this;
    }

    _createClass(Paginator, [{
        key: 'isFirstPage',
        value: function isFirstPage() {
            return this.getPage() === 0;
        }
    }, {
        key: 'isLastPage',
        value: function isLastPage() {
            return this.getPage() === this.getPageCount() - 1;
        }
    }, {
        key: 'getPageCount',
        value: function getPageCount() {
            return Math.ceil(this.props.totalRecords / this.props.rows) || 1;
        }
    }, {
        key: 'calculatePageLinkBoundaries',
        value: function calculatePageLinkBoundaries() {
            var numberOfPages = this.getPageCount();
            var visiblePages = Math.min(this.props.pageLinkSize, numberOfPages);

            //calculate range, keep current in middle if necessary
            var start = Math.max(0, Math.ceil(this.getPage() - visiblePages / 2));
            var end = Math.min(numberOfPages - 1, start + visiblePages - 1);

            //check when approaching to last page
            var delta = this.props.pageLinkSize - (end - start + 1);
            start = Math.max(0, start - delta);

            return [start, end];
        }
    }, {
        key: 'updatePageLinks',
        value: function updatePageLinks() {
            var pageLinks = [];
            var boundaries = this.calculatePageLinkBoundaries();
            var start = boundaries[0];
            var end = boundaries[1];

            for (var i = start; i <= end; i++) {
                pageLinks.push(i + 1);
            }

            return pageLinks;
        }
    }, {
        key: 'changeState',
        value: function changeState(first, rows) {
            var pc = this.getPageCount();
            var p = Math.floor(first / rows);

            if (p >= 0 && p < pc) {
                var newPageState = {
                    first: first,
                    rows: rows,
                    page: p,
                    pageCount: pc
                };

                if (this.props.onPageChange) {
                    this.props.onPageChange(newPageState);
                }
            }
        }
    }, {
        key: 'getPage',
        value: function getPage() {
            return Math.floor(this.props.first / this.props.rows);
        }
    }, {
        key: 'changePageToFirst',
        value: function changePageToFirst(event) {
            this.changeState(0, this.props.rows);
            event.preventDefault();
        }
    }, {
        key: 'changePageToPrev',
        value: function changePageToPrev(event) {
            this.changeState(this.props.first - this.props.rows, this.props.rows);
            event.preventDefault();
        }
    }, {
        key: 'onPageLinkClick',
        value: function onPageLinkClick(event, pageLink) {
            this.changeState((pageLink - 1) * this.props.rows, this.props.rows);
            event.preventDefault();
        }
    }, {
        key: 'changePageToNext',
        value: function changePageToNext(event) {
            this.changeState(this.props.first + this.props.rows, this.props.rows);
            event.preventDefault();
        }
    }, {
        key: 'changePageToLast',
        value: function changePageToLast(event) {
            this.changeState((this.getPageCount() - 1) * this.props.rows, this.props.rows);
            event.preventDefault();
        }
    }, {
        key: 'onRowsChange',
        value: function onRowsChange(event) {
            this.changeState(0, this.props.rowsPerPageOptions[event.target.selectedIndex]);
            event.preventDefault();
        }
    }, {
        key: 'createPaginatorElement',
        value: function createPaginatorElement(className, callback, disabled, icon) {
            var paginatorClassName = (0, _classnames2.default)(className, 'ui-paginator-element ui-state-default ui-corner-all', {
                'ui-state-disabled': disabled
            });
            var iconClassName = (0, _classnames2.default)('fa', icon);

            return _react2.default.createElement(
                'a',
                { href: '#', className: paginatorClassName, onClick: callback, tabIndex: disabled ? -1 : null },
                _react2.default.createElement('span', { className: iconClassName })
            );
        }
    }, {
        key: 'createPageLinkElements',
        value: function createPageLinkElements() {
            var _this2 = this;

            var pageLinks = this.updatePageLinks();
            var pageLinkElements = pageLinks.map(function (pageLink, i) {
                var pageClassName = (0, _classnames2.default)('ui-paginator-page ui-paginator-element ui-state-default ui-corner-all', {
                    'ui-state-active': pageLink - 1 === _this2.getPage()
                });

                return _react2.default.createElement(
                    'a',
                    { key: pageLink, href: '#', className: pageClassName, onClick: function onClick(e) {
                            return _this2.onPageLinkClick(e, pageLink);
                        } },
                    pageLink
                );
            });

            return _react2.default.createElement(
                'span',
                { className: 'ui-paginator-pages' },
                pageLinkElements
            );
        }
    }, {
        key: 'createRowsPerPageDropdown',
        value: function createRowsPerPageDropdown() {
            if (this.props.rowsPerPageOptions) {
                var options = this.props.rowsPerPageOptions.map(function (opt, i) {
                    return _react2.default.createElement(
                        'option',
                        { key: opt, value: opt },
                        opt
                    );
                });
                return _react2.default.createElement(
                    'select',
                    { className: 'ui-paginator-rpp-options ui-widget ui-state-default', onChange: this.onRowsChange.bind(this) },
                    options
                );
            } else {
                return null;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var className = (0, _classnames2.default)('ui-paginator ui-widget ui-widget-header ui-unselectable-text', this.props.className);
            var firstLink = this.createPaginatorElement('ui-paginator-first', this.changePageToFirst, this.isFirstPage(), 'fa-step-backward');
            var prevLink = this.createPaginatorElement('ui-paginator-prev', this.changePageToPrev, this.isFirstPage(), 'fa-backward');
            var nextLink = this.createPaginatorElement('ui-paginator-next', this.changePageToNext, this.isLastPage(), 'fa-forward');
            var lastLink = this.createPaginatorElement('ui-paginator-last', this.changePageToLast, this.isLastPage(), 'fa-step-forward');
            var pageLinks = this.createPageLinkElements();
            var rpp = this.createRowsPerPageDropdown();

            return _react2.default.createElement(
                'div',
                { className: className, style: this.props.style },
                firstLink,
                prevLink,
                pageLinks,
                nextLink,
                lastLink,
                rpp
            );
        }
    }]);

    return Paginator;
}(_react.Component);

Paginator.defaultProps = {
    totalRecords: 0,
    rows: 0,
    first: 0,
    pageLinkSize: 5,
    rowsPerPageOptions: null,
    style: null,
    className: null,
    onPageChange: null
};
Paginator.propsTypes = {
    totalRecords: _propTypes2.default.number,
    rows: _propTypes2.default.number,
    first: _propTypes2.default.number,
    pageLinkSize: _propTypes2.default.number,
    rowsPerPageOptions: _propTypes2.default.array,
    style: _propTypes2.default.string,
    className: _propTypes2.default.string,
    onPageChange: _propTypes2.default.func
};